#ifndef __ColorSpline_h__
#define __ColorSpline_h__

#ifndef __FACTStuff_h__
#include "FACTStuff.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

float Max(float a, float b);
float Min(float a, float b);
float Mod(float a, float b);
float Clamp(float n, float min, float max);
float BoxStep(float a, float b, float x);
float SmoothStep(float a, float b, float x);
float ValueSpline(float x, long nKnots, float *knot);
void ColorSpline(float x, long nKnots, ARGB_Real *knot, ARGB_Real *result);
void MixRGBColors(ARGB_Real *srcColor1, ARGB_Real *srcColor2, ARGB_Real *dstColor, float mix);
void MixARGBColors(ARGB_Real *srcColor1, ARGB_Real *srcColor2, ARGB_Real *dstColor, float mix);
void BlendRGBColors(ARGB_Real *srcColor1, ARGB_Real *srcColor2, ARGB_Real *dstColor, float mix);
void BlendARGBColors(ARGB_Real *srcColor1, ARGB_Real *srcColor2, ARGB_Real *dstColor, float mix);
void ApplyARGBColor(RGB_Real *srcColor1, ARGB_Real *srcColor2, RGB_Real *dstColor);

#ifdef __cplusplus
}
#endif

#endif