#ifndef		EI_DRAW_CONTEXT_H
#define		EI_DRAW_CONTEXT_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

EI_DrawContext *EI_MakeContextForImageBuffer(EI_ImageBuffer *iImage);
EI_DrawContext* EI_MakeContextForDialog(EI_Dialog *iDialog);
void EI_DestroyContext(EI_DrawContext *iContext);

void EI_SetClip(EI_DrawContext *ioContext,
				const EI_Rect *iClipRect);
void EI_GetClip(const EI_DrawContext *iContext,
				EI_Rect *oClipRect);

void EI_SetPenMode(EI_DrawContext *ioContext,
					EI_PenMode iPenMode);
EI_PenMode EI_GetPenMode(const EI_DrawContext *iContext);

void EI_MoveTo(EI_DrawContext *ioContext,
				int iPenH,
				int iPenV);
void EI_LineTo(EI_DrawContext *ioContext,
				int iPenH,
				int iPenV);
void EI_GetPenLocation(const EI_DrawContext *iContext,
						int *oPenH,
						int *oPenV);

void EI_SetForeColor(EI_DrawContext *ioContext,
						const EI_Color *iForeColor);
void EI_GetForeColor(const EI_DrawContext *iContext,
						EI_Color *oForeColor);

void EI_SetBackColor(EI_DrawContext *ioContext,
						const EI_Color *iBackColor);
void EI_GetBackColor(const EI_DrawContext *iContext,
						EI_Color *oBackColor);

void EI_FrameRect(EI_DrawContext *ioContext,
					const EI_Rect *iFrame);
void EI_PaintRect(EI_DrawContext *ioContext,
					const EI_Rect *iFrame);
void EI_EraseRect(EI_DrawContext *ioContext,
					const EI_Rect *iFrame);

void EI_FrameOval(EI_DrawContext *ioContext,
					const EI_Rect *iFrame);
void EI_PaintOval(EI_DrawContext *ioContext,
					const EI_Rect *iFrame);

void EI_DrawImage(EI_DrawContext *ioContext,
					const EI_ImageBuffer *iImage,
					const EI_Rect *iSourceRect,
					const EI_Rect *iDestRect);
void EI_CaptureImage(const EI_DrawContext *iContext,
						EI_ImageBuffer *iImage,
						const EI_Rect *iSourceRect,
						const EI_Rect *iDestRect);

void EI_SetTextSize(EI_DrawContext *ioContext,
					int iSize);
int EI_GetTextSize(const EI_DrawContext *iContext);

void EI_SetTextStyle(EI_DrawContext *ioContext,
						int iStyleFlags);
int EI_GetTextStyle(const EI_DrawContext *iContext);

int EI_MeasureText(const EI_DrawContext *iContext,
					const char *iText,
					int iNumChars);
void EI_GetFontMetrics(const EI_DrawContext *iContext,
						int *oAscent,
						int *oDescent,
						int *oLeading);

void EI_DrawText(EI_DrawContext *ioContext,
					const char *iText,
					int iNumChars);
void EI_DrawTextToFit(EI_DrawContext *ioContext,
						const char *iText,
						int iNumChars,
						int iMaxPixelWidth,
						int iAllowCondensed);
void EI_DrawTextInRect(EI_DrawContext *ioContext,
						const char *iText,
						int iNumChars,
						const EI_Rect *iBounds);

void EI_HiliteRect(EI_DrawContext *ioContext,
					const EI_Rect *iBounds,
					const EI_Color *iHiliteColor,
					const EI_Color *iBackColor);

#ifdef		__cplusplus
}
#endif

#endif
