#ifndef		EI_RECT_H
#define		EI_RECT_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

int EI_GetRectWidth(const EI_Rect *iRect);
int EI_GetRectHeight(const EI_Rect *iRect);

void EI_SetRect(EI_Rect *oRect,
				int iLeft,
				int iTop,
				int iRight,
				int iBottom);

int EI_IsRectEmpty(const EI_Rect *iRect);
int EI_IsPtInRect(const EI_Rect *iRect,
					int iX,
					int iY);

void EI_UnionRects(const EI_Rect *iRect1,
					const EI_Rect *iRect2,
					EI_Rect *oResult);
int EI_IntersectRects(const EI_Rect *iRect1,
						const EI_Rect *iRect2,
						EI_Rect *oResult);

void EI_InsetRect(EI_Rect *ioRect,
					int iInsetX,
					int iInsetY);
void EI_OffsetRect(EI_Rect *ioRect,
					int iOffsetX,
					int iOffsetY);

int EI_AreRectsEqual(const EI_Rect *iRect1,
						const EI_Rect *iRect2);

#ifdef		__cplusplus
}
#endif

#endif
