#ifndef		EI_STREAM_H
#define		EI_STREAM_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

EI_Stream *EI_OpenFileStream(const EI_FileRef *iFileRef,
								EI_StreamAccess iAccess);
void EI_CloseStream(EI_Stream *iStream);

int EI_SetStreamPosition(EI_Stream *iStream,
							long iPosition);
long EI_GetStreamPosition(EI_Stream *iStream);

long EI_GetStreamSize(EI_Stream *iStream);

int EI_ReadStream(EI_Stream *iStream,
					char *oBuffer,
					long *ioCount);
int EI_WriteStream(EI_Stream *iStream,
					char *iBuffer,
					long *ioCount);

int EI_WriteUInt8(EI_Stream *iStream,
					unsigned char iData);
int EI_WriteSInt16(EI_Stream *iStream,
					short iData);
int EI_WriteUInt16(EI_Stream *iStream,
					unsigned short iData);
int EI_WriteSInt32(EI_Stream *iStream,
					long iData);
int EI_WriteUInt32(EI_Stream *iStream,
					unsigned long iData);
int EI_WriteFloat32(EI_Stream *iStream,
					float iData);
int EI_WriteFloat64(EI_Stream *iStream,
					double iData);

int EI_ReadUInt8(EI_Stream *iStream,
					unsigned char *oData);
int EI_ReadSInt16(EI_Stream *iStream,
					short *oData);
int EI_ReadUInt16(EI_Stream *iStream,
					unsigned short *oData);
int EI_ReadSInt32(EI_Stream *iStream,
					long *oData);
int EI_ReadUInt32(EI_Stream *iStream,
					unsigned long *oData);
int EI_ReadFloat32(EI_Stream *iStream,
					float *oData);
int EI_ReadFloat64(EI_Stream *iStream,
					double *oData);

#ifdef		__cplusplus
}
#endif

#endif
