#ifndef TRACKCACHE_HPP
#define TRACKCACHE_HPP

struct CCacheValue;
struct CChunk;

long 	Type2Size( long dataType );
Boolean CompareChannelValues( void * data1, void * data2, long dataType );

struct CTrackCache {
	CTrackCache( void ) : mActive(false), mValue(0), mChunk(0) {}
   ~CTrackCache( void ) { Free(); }
   	
	Boolean IsActive( void ) { return mActive; }
	void    Free	( void );
	
	void *  Get ( char * grpID, long channelID, long frame );
	Boolean Put ( char * grpID, long channelID, long frame, void * src, long dataType );
	Boolean Look( char * grpID, long channelID );

private:
	CCacheValue * GetVal  ( char * grpID, long channelID, long frame );
	CCacheValue * AllocVal( long dataType );
	
// data members
	Boolean mActive;
	CCacheValue * mValue;
	CChunk * mChunk;
	
	friend struct CTrackControl;
};

struct CTrackControl {
	CTrackControl( CTrackCache * track, Boolean active );
   ~CTrackControl( void );

// data members
	CTrackCache * mCache;
};

inline CTrackControl::CTrackControl( CTrackCache * cache, Boolean active ) : mCache(cache) 
{ 
	mCache->mActive = active; 
}

inline CTrackControl::~CTrackControl( void )
{
	if (!mCache->mActive) mCache->Free();
}
 
#endif // TRACKCACHE_HPP