/*
Copyright 1993-1998 Electric Image, Inc. This source code may only be used by
registered owners of the ElectricImage Plug-In Kit. Owners of the Kit may
include the source code in their products (freeware, shareware, or commercial).
This copyright notice must be included in its original form in all such
products. This source code may not be offered for sale or distributed by any
entity without the written permission of Electric Image, Inc.
*/

#include "System.h"

void ReverseField(void* theField, long size)
{
	char *start, *end;
	char temp;
	
	start = (char*)theField;
	end = start + size - 1;
	while (start < end) {
		temp = *start;
		*start = *end;
		*end = temp;
		start++;
		end--;
	}
}  /* ReverseField */

#ifdef __SGI__
ulong gTickCount = 0;
#endif

#ifndef __MACINTOSH__
#ifndef __WIN32__
#include <time.h>

/* Note: Don't use this function.  This is way slow */
long GetTick(void);
long GetTick(void)
{
	return clock() / (CLOCKS_PER_SEC / 60.0);
}  /* GetTick */

void GetDate(ulong* secs);
void GetDate(ulong* secs)
{
	*secs = (ulong)time(nil);
}  /* GetDate */
#endif
#endif

short IAbs(short value)
{
	return (short)(value < 0 ? -value : value);
}  /* IAbs */

long LAbs(long value)
{
	return value < 0 ? -value : value;
}  /* LAbs */

float RAbs(float value)
{
	return value < 0.0 ? -value : value;
}  /* RAbs */

double DAbs(double value)
{
	return value < 0.0 ? -value : value;
}  /* DAbs */
