#ifndef		EI_FILE_REF_H
#define		EI_FILE_REF_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

#define EI_MAKE_FILE_TYPE(a, b, c, d) \
	((unsigned long) (((unsigned long) ((a) << 24)) | \
	((unsigned long) ((b) << 16)) | \
	((unsigned long) ((c) << 8)) | \
	((unsigned long) (d))))
	

EI_DirectoryRef *EI_MakeDirectoryRef(void);
void EI_DestroyDirectoryRef(EI_DirectoryRef *iDirectoryRef);

int EI_AppendDirectoryName(EI_DirectoryRef *ioDirectoryRef,
							const char *iDirectoryString);
void EI_RemoveLastDirectoryName(EI_DirectoryRef *ioDirectoryRef);

int EI_GetNumDirectoryNames(const EI_DirectoryRef *iDirectoryRef);
int EI_GetDirectoryNameSize(const EI_DirectoryRef *iDirectoryRef,
							int iNameIndex);
void EI_GetDirectoryName(const EI_DirectoryRef *iDirectoryRef,
							int iNameIndex,
							char *iText,
							int *ioNumChars);

int EI_GetDirectoryPathNameSize(const EI_DirectoryRef *iDirectoryRef);
void EI_GetDirectoryPathName(const EI_DirectoryRef *iDirectoryRef,
								char *iText,
								int *ioNumChars);

EI_DirectoryRef *EI_GetHomeDirectory(void);
EI_DirectoryRef *EI_GetPreferencesDirectory(void);
EI_DirectoryRef *EI_GetTemporaryDirectory(void);

int EI_CreateDirectory(const EI_DirectoryRef *iDirectoryRef);

EI_FileRef *EI_MakeEmptyFileRef(void);
EI_FileRef *EI_MakeFileRef(const EI_DirectoryRef *iDirectoryRef,
							const char *iNameString,
							unsigned long iFileType,
							const char *iExtensionString);
void EI_DestroyFileRef(EI_FileRef *iFileRef);

EI_DirectoryRef *EI_GetFileDirectory(EI_FileRef *iFileRef);
int EI_SetFileDirectory(EI_FileRef *iFileRef,
						const EI_DirectoryRef *iNewDirectoryRef);

int EI_SetFileRefType(EI_FileRef *iFileRef,
						unsigned long iFileType);
unsigned long EI_GetFileRefType(const EI_FileRef *iFileRef);

int EI_SetFileRefExtension(EI_FileRef *iFileRef,
							const char *iExtensionString);
int EI_GetFileRefExtensionSize(const EI_FileRef *iFileRef);
void EI_GetFileRefExtension(const EI_FileRef *iFileRef,
							char *iText,
							int *ioNumChars);

int EI_SetFileName(EI_FileRef *iFileRef,
					const char *iNameString);
int EI_GetFileNameSize(const EI_FileRef *iFileRef);
void EI_GetFileName(const EI_FileRef *iFileRef,
					char *iText,
					int *ioNumChars);

int EI_GetFilePathNameSize(const EI_FileRef *iFileRef);
void EI_GetFilePathName(const EI_FileRef *iFileRef,
						char *iText,
						int *ioNumChars);

EI_FileRef *EI_AskUserForNewFile(const char *iPromptString);
EI_FileRef *EI_AskUserForExistingFile(const char *iPromptString);

int EI_DeleteFile(const EI_FileRef *iFileRef);

#ifdef		__cplusplus
}
#endif

#endif
