#ifndef		EI_IMAGE_BUFFER_H
#define		EI_IMAGE_BUFFER_H

#ifndef		EI_TYPES_H
#include	"EI_Types.h"
#endif

#ifdef		__cplusplus
extern "C" {
#endif

EI_ImageBuffer *EI_MakeImageBuffer(const EI_Rect *iBounds);
void EI_DestroyImageBuffer(EI_ImageBuffer *iImage);

int EI_GetBufferRowBytes(const EI_ImageBuffer *iImage);
char *EI_GetBufferBaseAddress(EI_ImageBuffer *iImage);
void EI_GetBufferBounds(const EI_ImageBuffer *iImage,
						EI_Rect *oRect);

#define EI_MAKE_PIXEL(iRed, iGreen, iBlue, iAlpha) \
	(((EI_32BitPixel) ((iRed) & 0xFF) << cEI_RedShift) | \
	((EI_32BitPixel) ((iGreen) & 0xFF) << cEI_GreenShift) | \
	((EI_32BitPixel) ((iBlue) & 0xFF) << cEI_BlueShift) | \
	((EI_32BitPixel) ((iAlpha) & 0xFF) << cEI_AlphaShift))

#define EI_GET_PIXEL_RED(pixel) \
	((unsigned char) ((pixel) >> cEI_RedShift) & 0xFF)
#define EI_SET_PIXEL_RED(pixel, iRed) \
	((pixel) = ((pixel) & ~((EI_32BitPixel) 0xFF << cEI_RedShift)) | \
	((iRed) << cEI_RedShift))

#define EI_GET_PIXEL_GREEN(pixel) \
	((unsigned char) ((pixel) >> cEI_GreenShift) & 0xFF)
#define EI_SET_PIXEL_GREEN(pixel, iGreen) \
	((pixel) = ((pixel) & ~((EI_32BitPixel) 0xFF << cEI_GreenShift)) | \
	((iGreen) << cEI_GreenShift))

#define EI_GET_PIXEL_BLUE(pixel) \
	((unsigned char) ((pixel) >> cEI_BlueShift) & 0xFF)
#define EI_SET_PIXEL_BLUE(pixel, iBlue) \
	((pixel) = ((pixel) & ~((EI_32BitPixel) 0xFF << cEI_BlueShift)) | \
	((iBlue) << cEI_BlueShift))

#define EI_GET_PIXEL_ALPHA(pixel) \
	((unsigned char) ((pixel) >> cEI_AlphaShift) & 0xFF)
#define EI_SET_PIXEL_ALPHA(pixel, iAlpha) \
	((pixel) = ((pixel) & ~((EI_32BitPixel) 0xFF << cEI_AlphaShift)) | \
	((iAlpha) << cEI_AlphaShift))

#define EI_GET_PIXEL_ALL(pixel, oRed, oGreen, oBlue, oAlpha) \
	((oRed) = EI_GET_PIXEL_RED(pixel), \
	(oGreen) = EI_GET_PIXEL_GREEN(pixel), \
	(oBlue) = EI_GET_PIXEL_BLUE(pixel), \
	(oAlpha) = EI_GET_PIXEL_ALPHA(pixel))

#define EI_SET_PIXEL_ALL(pixel, iRed, iGreen, iBlue, iAlpha) \
	((pixel) = EI_MAKE_PIXEL(iRed, iGreen, iBlue, iAlpha))

#ifdef		__cplusplus
}
#endif

#endif
