/*
Copyright 1996-1998 Electric Image, Inc. This source code may only be used by
registered owners of the ElectricImage Plug-In Kit. Owners of the Kit may
include the source code in their products (freeware, shareware, or commercial).
This copyright notice must be included in its original form in all such
products. This source code may not be offered for sale or distributed by any
entity without the written permission of Electric Image, Inc.
*/

#ifndef __MemoryUtils_h__
#define __MemoryUtils_h__

#ifndef _STRING_H
#include <string.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

/* Memory copying routines */

#define CopyMem(sourcePtr, destPtr, byteCount)	memcpy(destPtr, sourcePtr, byteCount)

void CopySmallBlockForwards(void* sourcePtr, void* destPtr, unsigned long byteCount);
void CopySmallBlockBackwards(void* sourcePtr, void* destPtr, unsigned long byteCount);

/* PowerPC specific routines */

#if powerc
unsigned long GetCR(void);
void SetCR(unsigned long value);
unsigned long GetMSR(void);
void SetMSR(unsigned long value);
void ZeroCache(void* startNum, unsigned long count, unsigned long size);	/* Clears 32 byte cache blocks */
void TouchCache(void* startNum, unsigned long count, unsigned long size);	/* Touches 32 byte cache blocks */
void TouchSCache(void* startNum, unsigned long count, unsigned long size);	/* Touches for store 32 byte cache blocks */
void FlushCache(void* startNum, unsigned long count, unsigned long size);	/* Flushes 32 byte cache blocks */
#endif

/* Memory initialization routines */

void ZeroMem(void* startNum, unsigned long rangeNum);
void FillMem(void* startNum, unsigned long rangeNum, unsigned long valueNum);

#ifdef __cplusplus
}
#endif

#endif
